routes/web.php
<?php

use App\Http\Controllers\EstablecimientoController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('establecimiento', EstablecimientoController::class);

app/Models/Establecimiento.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Establecimiento extends Model
{
    use HasFactory;
    protected $fillable = ['nombre','direction','region','latitud','longitud'];
}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/AutocompleteController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class AutocompleteController extends Controller
{
    //
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/EstablecimientoController.php
<?php

namespace App\Http\Controllers;

use App\Models\Establecimiento;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;

class EstablecimientoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()

    {
        //

        $establecimientos = Establecimiento::paginate(4);
        return view('establecimiento.index')->with('establecimientos', $establecimientos);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //

        return view('establecimiento.form');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // definiremos reglas de validación en nuestro formulario
        $request->validate([
            'nombre' => 'required|max:30',
            'direction' => 'required|max:30',
            'region' => 'required|max:20',
            'latitud' => 'required',
            'longitud' => 'required',
        ]);

        $establecimiento = Establecimiento::create($request->only('nombre', 'direction', 'region', 'latitud', 'longitud'));
        Session::flash('mensaje', 'Registro creado con exito');
        return redirect()->route('establecimiento.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Establecimiento  $establecimiento
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //

        $establecimiento = Establecimiento::find($id);

        return view('establecimiento.show')->with('establecimiento',$establecimiento);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Establecimiento  $establecimiento
     * @return \Illuminate\Http\Response
     */
    public function edit(Establecimiento $establecimiento)
    {
        //

        return view('establecimiento.form')->with('establecimiento', $establecimiento);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Establecimiento  $establecimiento
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Establecimiento $establecimiento)
    {
        //

        // definiremos reglas de validación en nuestro formulario
        $request->validate([
            'nombre' => 'required|max:30',
            'direction' => 'required|max:30',
            'region' => 'required|max:20',
            'latitud' => 'required',
            'longitud' => 'required',
        ]);

        $establecimiento->nombre = $request['nombre'];
        $establecimiento->direction = $request['direction'];
        $establecimiento->región = $request['region'];
        $establecimiento->latitud = $request['latitud'];
        $establecimiento->longitud = $request['longitud'];
        $establecimiento->save();


        Session::flash('mensaje', 'Registro editado con exito');
        return redirect()->route('establecimiento.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Establecimiento  $establecimiento
     * @return \Illuminate\Http\Response
     */
    public function destroy(Establecimiento $establecimiento)
    {
        //
        $establecimiento->delete();
        Session::flash('mensaje', 'Registro eliminado con exito!');
        return redirect()->route('establecimiento.index');
    }
}

resources/views/establecimiento/form.blade.php
@extends('theme.base')


@section('content')
    <div class="container py-5 text-center">

        @if (isset($establecimiento))
            <h1>Editar Establecimiento</h1>
        @else
            <h1>Crear Establecimiento</h1>
        @endif

        @if (isset($establecimiento))
            <form action="{{ route('establecimiento.update', $establecimiento) }}" method="post"
                class="w-50 p-3 form-horizontal" style="margin: 0 auto ">
                @method('PUT')
            @else
                <form action="{{ route('establecimiento.store') }}" method="post" class="w-50 p-3 form-horizontal"
                    style="margin: 0 auto ">
        @endif



        @csrf
        <!--Nombre-->
        <div class="mb-2">
            <label for="nombre" class="form-label">Nombre</label>
            <input type="text" value="{{ old('nombre') ?? @$establecimiento->nombre }}" class="form-control"
                name="nombre" placeholder="Ingrese el nombre">
            @error('nombre')
                <p class="form-text text-danger ">{{ $message }}</p>
            @enderror
        </div>

        <!--Dirección-->
        <div class="mb-3">
            <label for="direction" class="form-label">Dirección</label>
            <input type="text" value="{{ old('direction') ?? @$establecimiento->direction }}" class="form-control"
                name="direction" placeholder="Ingrese la dirección">
            @error('direction')
                <p class="form-text text-danger ">{{ $message }}</p>
            @enderror
        </div>

        <!--Región-->
        <div class="mb-3">
            <label for="region" class="form-label">Región</label>
            <input type="text" value="{{ old('region') ?? @$establecimiento->region }}" class="form-control"
                name="region" placeholder="Ingrese la región">
            @error('region')
                <p class="form-text text-danger ">{{ $message }}</p>
            @enderror
        </div>

        <!--Latitud-->
        <div class="mb-3">
            <label for="latitud" class="form-label">Latitud</label>
            <input type="number" id="latitud" value="{{ old('latitud') ?? @$establecimiento->latitud }}"
                class="form-control" name="latitud" placeholder="Ingrese la latitud" step="0.000000000000001">
            @error('latitud')
                <p class="form-text text-danger ">{{ $message }}</p>
            @enderror
        </div>


        <!--Longitud-->
        <div class="mb-3">
            <label for="longitud" class="form-label">Longitud</label>
            <input type="number" id="longitud"
                value="{{ old('longitud') ?? @$establecimiento->longitud }}"class="form-control" name="longitud"
                placeholder="Ingrese la longitud" step="0.000000000000001">
            @error('longitud')
                <p class="form-text text-danger ">{{ $message }}</p>
            @enderror
        </div>


        @if (isset($establecimiento))
            <button type="submit" class="btn btn-success">Editar Establecimiento</button>
        @else
            <button type="submit" id="guardar" class="btn btn-success">Guardar Establecimiento</button>
        @endif

        </form>
    </div>


    <div class="card" id="mapa" style="width: 300px; height:300px;margin: 0 auto ">Parte del mapa
     

       <script >

            
            $("#guardar").click(function() {
                let lat = $("#latitud").val();
                let lng = $("#longitud").val();

                coordenadas = {
                    lng: lng,
                    lat: lat
                }

                generarMapa(coordenadas);

            });

            function initMap() {
                let latitud = -33.4708251007103;
                let longitud = -70.65136876967257;

                coordenadas = {
                    lng: longitud,
                    lat: latitud
                }

                generarMapa(coordenadas);
            }


            function generarMapa(coordenadas) {
                let mapa = new google.maps.Map(document.getElementById('mapa'), {
                    zoom: 12,
                    center: new google.maps.LatLng(coordenadas.lat, coordenadas.lng)
                });

                marcador = new google.maps.Marker({
                    map: mapa,
                    draggable: true,
                    position: new google.maps.LatLng(coordenadas.lat, coordenadas.lng)
                });
                marcador.addListener('dragend', function(event) {
                    document.getElementById("latitud").value = this.getPosition().lat();
                    document.getElementById("longitud").value = this.getPosition().lng();
                });

            }
        </script>

        <script
            src="https://maps.googleapis.com/maps/api/js?key=AIzaSyCMrOTQePpXvu0FlI3Gm4zqfO1uDhZIEkc&region=CL&libraries=places&callback=initMap">
        </script>
    @endsection

resources/views/establecimiento/index.blade.php
@extends('theme.base')


@section('content')
    <div class="container py-5 text-center">
        <h1>Listado de Establecimientos</h1>
        <a href="{{ route('establecimiento.create') }}" class="btn btn-primary btn-icon-text mb-2 mb-md-0"><svg
                xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="currentColor" class="bi bi-plus"
                viewBox="0 0 20 20">
                <path
                    d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4z" />
            </svg>
            Crear Establecimiento</a>

        @if (Session::has('mensaje'))
            <div class="alert alert-info my-5">
                {{ Session::get('mensaje') }}
            </div>
        @endif

        <!--hshshshshshshhshsshshshs-->
        <table class="table">
            <thead>
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Nombre</th>
                    <th scope="col">Dirección</th>
                    <th scope="col">Región</th>
                    <th scope="col">Latitud</th>
                    <th scope="col">Longitud</th>
                    <th scope="col">Acción</th>
                </tr>
            </thead>
            <tbody>

                @forelse ($establecimientos as $establecimiento)
                    <tr>
                        <td>{{ $establecimiento->id }}</td>
                        <td>{{ $establecimiento->nombre }}</td>
                        <td>{{ $establecimiento->direction }}</td>
                        <td>{{ $establecimiento->region }}</td>
                        <td>{{ $establecimiento->latitud }}</td>
                        <td>{{ $establecimiento->longitud }}</td>
                        <td>
                            <a href="{{ route('establecimiento.show', $establecimiento->id) }}"
                                class="btn btn-success btn-sm"><svg xmlns="http://www.w3.org/2000/svg" width="18"
                                    height="18" fill="currentColor" style="align-items: center" class="bi bi-eye"
                                    viewBox="0 0 16 16">
                                    <path
                                        d="M16 8s-3-5.5-8-5.5S0 8 0 8s3 5.5 8 5.5S16 8 16 8zM1.173 8a13.133 13.133 0 0 1 1.66-2.043C4.12 4.668 5.88 3.5 8 3.5c2.12 0 3.879 1.168 5.168 2.457A13.133 13.133 0 0 1 14.828 8c-.058.087-.122.183-.195.288-.335.48-.83 1.12-1.465 1.755C11.879 11.332 10.119 12.5 8 12.5c-2.12 0-3.879-1.168-5.168-2.457A13.134 13.134 0 0 1 1.172 8z" />
                                    <path
                                        d="M8 5.5a2.5 2.5 0 1 0 0 5 2.5 2.5 0 0 0 0-5zM4.5 8a3.5 3.5 0 1 1 7 0 3.5 3.5 0 0 1-7 0z" />
                                </svg>Ver</a>
                            <i class="bi bi-brush"></i>
                   

                            <a href="{{ route('establecimiento.edit', $establecimiento->id) }}"
                                class="btn btn-warning btn-sm"><svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="currentColor" class="bi bi-link" viewBox="0 0 16 16">
                                    <path d="M6.354 5.5H4a3 3 0 0 0 0 6h3a3 3 0 0 0 2.83-4H9c-.086 0-.17.01-.25.031A2 2 0 0 1 7 10.5H4a2 2 0 1 1 0-4h1.535c.218-.376.495-.714.82-1z"/>
                                    <path d="M9 5.5a3 3 0 0 0-2.83 4h1.098A2 2 0 0 1 9 6.5h3a2 2 0 1 1 0 4h-1.535a4.02 4.02 0 0 1-.82 1H12a3 3 0 1 0 0-6H9z"/>
                                  </svg> Editar</a>
                            <form action="{{ route('establecimiento.destroy', $establecimiento) }}" class="d-inline"
                                method="post">
                                @method('DELETE')
                                @csrf
                                <button type="submit" onclick="return confirm('¿Esta seguro de eliminar el registro?')"
                                    class="btn btn-danger btn-sm">Eliminar</button>

                            </form>

                        </td>
                    </tr>
                @empty

                    <tr>
                        <td colspan="3">No existen registros</td>
                    </tr>
                @endforelse
            </tbody>
        </table>

        {{ $establecimientos->links() }}

    </div>
@endsection

resources/views/establecimiento/show.blade.php
@extends('theme.base')


@section('content')
    <div class="card text-center w-50 p-3" style="margin: 0 auto;margin-top:20px ">

        <div class="card-header">Detalles de Establecimiento: {{ $establecimiento->id }}</div>
        <div class="card-body">
            <h5 class="card-title">Nombre: {{ $establecimiento->nombre }} </h5>
            <p class="card-text">Dirección: {{ $establecimiento->direction }}</p>
            <p class="card-text">Región: {{ $establecimiento->region }}</p>
            <p class="card-text" >Latitud: {{ $establecimiento->latitud }}</p>
            <p class="card-text" id="longitud">Longitud: {{ $establecimiento->longitud }}</p>
        </div>



        <div class="card" id="mapa" style="width: 300px; height:300px;margin: 0 auto ">Parte del mapa
            <script>
                function initMap() {
                    let latitud = 19.388672;
                    let longitud = -99.174023;

                    coordenadas = {
                        lng: longitud,
                        lat: latitud
                    }

                    generarMapa(coordenadas);
                }


                function generarMapa(coordenadas) {
                    let mapa = new google.maps.Map(document.getElementById('mapa'), {
                        zoom: 12,
                        center: new google.maps.LatLng(coordenadas.lat, coordenadas.lng)
                    });

                    marcador = new google.maps.Marker({
                        map: mapa,
                        draggable: true,
                        position: new google.maps.LatLng(coordenadas.lat, coordenadas.lng)
                    });
                    marcador.addListener('dragend', function(event) {
                        document.getElementById("latitud").value = this.getPosition().lat();
                        document.getElementById("longitud").value = this.getPosition().lng();
                    });

                }
            </script>

            <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBD7Rmh9dkpF8wpYcaVA7obVdYyPm8ODPw&callback=initMap">
            </script>
            <br>

            <br>



            <br>
            **
            **
            **
            **
            **
            **
        </div>
    </div>
@endsection

resources/views/theme/base.blade.php
<!doctype html>
<html lang="en">

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">

    <title>RETC</title>
</head>

<body>

    @yield('content')
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous">
    </script>

</body>

</html>